import { SoftpakConnector } from "./softpakConnector.js";

class Implementation {

  constructor() {
    this.t3d = null;
    this.softpakConnector = null;
  }

  init(t3d) {
    this.t3d = t3d;
    /* Connector */
    const parsedUrl = new URL(window.location.href);
    let baseUrl = parsedUrl.protocol + "//" + parsedUrl.hostname + ":8443/DpApp";
    //let baseUrl = "http://app.matranscustomers.nl:8443/DpApp"
        
    let companycode = "pcs"
    let depotcode = '04';
    this.softpakConnector = new SoftpakConnector(t3d, baseUrl, companycode, depotcode);
    this.softpakConnector.stackCodes = "01A,01B,01C,01D,01E,01F,01G,01H,01J,01K,01L,01M,01N,01O,01P,01Q,01R,01S,02A,02B,02C,02D,02F,02H,02K,02M,02E,02G,02J,02L,03C,03E,03G,03J,03L,03D,03F,03H,03K"
    this.softpakConnector.login().then(() => {

      this.softpakConnector.getData('locations').then(locationData => {
        let locations = locationData.response.dsStacklocation.dsLocation.tt_stacklocation || []

        let stacks, x, yAnchor;

        // Stacks 'Straat 1' 
        yAnchor = 6000;

        x = - 800;
        stacks = ['01A', '01C', '01E', '01G', '01J', '01L', '01N'];
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], -1, locations);
        }

        x = - 1350;
        stacks = ['01B', '01D', '01F', '01H', '01K', '01M'];
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], 1, locations);
        }

        x = - 10200;
        stacks = ['01O', '01Q'];
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], 1, locations);
        }

        x = - 11100;
        stacks = ['01P'];
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], -1, locations);
        }

        x = - 12700;
        stacks = ['01R'];
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], -1, locations);
        }

        x = - 14000;
        stacks = ['01S'];
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], 1, locations);
        }
        
        // Stacks 'Straat 2' 
        stacks = ['02A'];
        x = 9500;
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], 1, locations);
        }

        stacks = ['02B'];
        x = 8600;
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], -1, locations);
        }

        stacks = ['02C'];
        x = 7850;
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], 1, locations);
        }

        stacks = ['02D', '02F', '02H', '02K', '02M'];
        x = 7000;
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], -1, locations);
        }

        stacks = ['02E', '02G', '02J', '02L'];
        x = 6450;
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], 1, locations);
        }

        // Stacks 'Straat 3' 
        stacks = ['03C', '03E', '03G', '03J', '03L'];
        x = 8050;
        yAnchor = 500;
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], 1, locations);
        }

        stacks = ['03D', '03F', '03H', '03K'];
        x = 7150;
        for (let istacks = 0; istacks < stacks.length; istacks++) {
          x = x - 1450;
          this._createLocations(x, yAnchor, stacks[istacks], -1, locations);
        }

        this.softpakConnector.getData('containers').then(data => {
          this.softpakConnector.processContainers(data);
          loadVisualScript('Customer');
        });
        
        window.setInterval(() => {
          this.softpakConnector.getData('containers').then(data => {
            this.softpakConnector.processContainers(data);
          });
        }, 10000);

        
      });

      this.t3d.view.viewLogo.addLogo('assets/logo/MRT.svg', -6500, -1000, 20);

    });
  }

  _createLocations(x, y, stackcode, modifier, locations) {

    let iBayGrid = 114;
    let baynrs = [];

    let groundPlane = { x: x, y: y + 200, rotation: 90, labels: [{ text: stackcode.toString(), x: 30, y: 30 }] };
    this.t3d.equipmentController.addGroundPlane(groundPlane);

    for (let i = 0; i < locations.length; i++) {
      let location = locations[i];
      
      if (location.stackcode === stackcode) {

 
        if(!((stackcode === "01A" || stackcode === "01B") && location.rownr > 3)) {  // 01A en 01B afkappen op 3 diep
          let found = false;
          for (let ib = 0; ib < baynrs.length; ib++) {
            if (baynrs[ib] === location.baynr) { found = true }
          }
          if (found === false) {
            baynrs.push(location.baynr);
          }

          let size = 420;
          if (location.baynr % 2 !== 0) {
            size = 210;
          }

          let hidden = true;
          if (location.baynr % 2 !== 0) {
            hidden = false;
          }

          let color = 0x71eef4;
          if (location.ind_inactive === true) {
            color = 0xaaaaaa;
          } else if (location.ind_reeferpoint) {
            color = 0x3655d1;
          }
          let sl = this.t3d.locationController.addStackLocation(x + ((location.rownr - 1) * (100 * modifier)), y - (location.baynr * iBayGrid), (location.tiernr - 1) * 80, "RMG", 0, hidden, location.stacklocation, size, color);
        }
      }
    }
  
    /* Bay labels */
    groundPlane = {x: x - (100 * modifier), y: y, rotation: 90, labels: []};
    for(let ib = 0; ib < baynrs.length; ib++) {
      let baynr = baynrs[ib];
      if( baynr % 2 !== 0) {
        let label = {text: baynr.toString(), x: (ib + 1) * iBayGrid, y: 30 };
        groundPlane.labels.push(label);
      }
    }
    this.t3d.equipmentController.addGroundPlane(groundPlane);

  }

  changeLocation(containers, location, mode) {
    let containerIds = [];
    for (let i = 0; i < containers.length; i++ ) {
      let container = containers[i];
      containerIds.push(container.properties.extId);
      console.log(container);
    }
    let containerIdList = containerIds.join(',');
    let result = this.softpakConnector.changeLocation(containerIdList, location.locationCode, mode);
    let message = '';
    if (result.response.plOk === true) {
      message = "Relocate order created";
    } else {
      message = "Error!\n" + result.response.pcErrorMessage;
    }
    alert(message);
  }

}

var visObj = [
  {
    name: 'Customer',
    code: "let ICL = 0xC41616;\nlet EIM = 0xe8bd6d;\nlet SEATRADE = 0xb5744c;\nlet SCA = 0x16C416;\nlet SAM = 0x1616C4;\n\n\n\n  container.opacity = 1;\n  if (container.properties.customer === 'ICL') {container.color = ICL}; \n  if (container.properties.customer === 'EIM') {container.color = EIM}; \n  if (container.properties.customer === 'SEATRADE') {container.color = SEATRADE}; \n  if (container.properties.customer === 'SCA') {container.color = SCA}; \n  if (container.properties.customer === 'SAM') {container.color = SAM}; \n\nmyT3d.legend.add('#C41616', 'ICL'); \nmyT3d.legend.add('#e8bd6d', 'EIM'); \nmyT3d.legend.add('#b5744c', 'SEATRADE'); \nmyT3d.legend.add('#16c416', 'SCA'); \nmyT3d.legend.add('#1616C4', 'SAM'); "
  },
  {
    name: 'IMDG',
    code: "if (container.properties.dangerousGoods && container.properties.dangerousGoods === 'YES') {\n  container.color = 0xff0000;\n  container.opacity = 1;\n  container.wireframe = false;\n} else {\n  container.color = 0x0000ff;\n  container.opacity = 0.5;}"
  }
]

export { Implementation, visObj }